;processed
; 0 -> 2 team scores or not
; 2 -> 3 feelings changes due to fatigue, reputation, and possesion
; 3 -> 4 feelings changes as time goes

(defrule score1 (declare(salience 150))
	?P <- (prestate (processed 0)(team1 ?team1)(team2 ?team2)(off1 A)(def2 C))
	=>
	(modify ?P (processed 1))
	(assert (scores ?team1 ?team2))
)

(defrule score2 (declare(salience 100))
	?P <- (prestate (processed 0)(team1 ?team1)(team2 ?team2)(off1 ?off1)(def2 ?def2)(pos1 ?pos1)(pos2 ?pos2))
	(test
		(and
			(or
				(and (eq ?off1 A) (eq ?def2 B))
				(and (eq ?off1 B) (eq ?def2 C))
			)

			(or
				(and (eq ?pos1 A) (eq ?pos2 B))
				(and (eq ?pos1 A) (eq ?pos2 C))
				(and (eq ?pos1 B) (eq ?pos2 C))
			)
		)
	)
	=>
	(modify ?P (processed 1))
	(assert (scores ?team1 ?team2))
)

(defrule notscore12 (declare(salience 50))
	?P <- (prestate (processed 0)(team1 ?team1)(team2 ?team2))
	=>
	(modify ?P (processed 1))
	(assert (notscore ?team1 ?team2))
)

(defrule score3 (declare(salience 150))
	?P <- (prestate (processed 1)(team1 ?team1)(team2 ?team2)(def1 C)(off2 A))
	=>
	(modify ?P (processed 2))
	(assert (scores ?team2 ?team1))
)

(defrule score4 (declare(salience 100))
	?P <- (prestate (processed 1)(team1 ?team1)(team2 ?team2)(def1 ?def1)(off2 ?off2)(pos1 ?pos1)(pos2 ?pos2))
	(test
		(and
			(or
				(and (eq ?off2 A) (eq ?def1 B))
				(and (eq ?off2 B) (eq ?def1 C))
			)

			(or
				(and (eq ?pos2 A) (eq ?pos1 B))
				(and (eq ?pos2 A) (eq ?pos1 C))
				(and (eq ?pos2 B) (eq ?pos1 C))
			)
		)
	)
	=>
	(modify ?P (processed 2))
	(assert (scores ?team2 ?team1))
)

(defrule notscore34 (declare(salience 50))
	?P <- (prestate (processed 1)(team1 ?team1)(team2 ?team2))
	=>
	(modify ?P (processed 2))
	(assert (notscore ?team2 ?team1))
)

(defrule goal1
	(prestate (processed 2))
	?S <- (scores ?team1 ?team2)
	?M <- (match(A-nation ?team1)(B-nation ?team2)(A-score ?score1)(B-score ?score2))
	?T1 <- (team(name ?team1)(morale ?mor1)(concentration ?con1))
	?T2 <- (team(name ?team2)(morale ?mor2)(concentration ?con2))
	=>
	(retract ?S)
	(modify ?M (A-score (+ 1 ?score1)))
	(modify ?T1 (morale (+ 25 ?mor1))(concentration (+ 10 ?con1)))
	(modify ?T2 (morale (- 15 ?mor2))(concentration (- 10 ?con2)))
)

(defrule goal2
	(prestate (processed 2))
	?S <- (scores ?team2 ?team1)
	?M <- (match(A-nation ?team1)(B-nation ?team2)(A-score ?score1)(B-score ?score2))
	?T1 <- (team(name ?team1)(morale ?mor1)(concentration ?con1))
	?T2 <- (team(name ?team2)(morale ?mor2)(concentration ?con2))
	=>
	(retract ?S)
	(modify ?M (B-score (+ 1 ?score2)))
	(modify ?T1 (morale (- 15 ?mor1))(concentration (- 10 ?con2)))
	(modify ?T2 (morale (+ 25 ?mor2))(concentration (+ 10 ?con1)))
)

(defrule feelingchange1
	?P <- (prestate (processed 2)(team1 ?team1)(team2 ?team2)(pos1 ?pos1)(pos2 ?pos2))
	?T1 <- (team(name ?team1)(reputation ?rep1)(morale ?mor1)(fatigue ?fat1)(concentration ?con1))
	?T2 <- (team(name ?team2)(reputation ?rep2)(morale ?mor2)(fatigue ?fat2)(concentration ?con2))
	=>
	(modify ?P (processed 3))
	(modify ?T1 (concentration ( - ?con1 (integer(/ ?fat1 20)) ) ))
	(modify ?T2 (concentration ( - ?con2 (integer(/ ?fat2 20)) ) ))
)

(defrule feelingchange2
	?P <- (prestate (processed 3)(team1 ?team1)(team2 ?team2))
	?T1 <- (team(name ?team1)(reputation ?rep1)(morale ?mor1))
	?T2 <- (team(name ?team2)(reputation ?rep2)(morale ?mor2))
	=>
	(modify ?P (processed 4))
	(if ( > ?rep1 ?mor1)
		then (modify ?T1 (morale ( + ?mor1 (integer(/ (- ?rep1 ?mor1) 5)) ) ))
	)
	(if ( > ?rep2 ?mor2)
		then (modify ?T2 (morale ( + ?mor2 (integer(/ (- ?rep2 ?mor2) 5)) ) ))
	)
)	

(defrule feelingchange3-1
	?P <- (prestate (processed 4)(team1 ?team1)(team2 ?team2))
	?T1 <- (team(name ?team1)(morale ?mor1)(concentration ?con1))
	?T2 <- (team(name ?team2)(morale ?mor2)(concentration ?con2))
	?M <- (match(A-nation ?team1)(B-nation ?team2)(A-location "Home")(time-slot ?time))
	=>
	(modify ?P (processed 5))
	(modify ?T1 (morale (+ ?mor1 5)) (concentration (+ ?con1 3)) )
	(modify ?T2 (morale (- ?mor2 3)) (concentration (- ?con2 2)) )
)

(defrule feelingchange3-2
	?P <- (prestate (processed 4)(team1 ?team1)(team2 ?team2))
	?T1 <- (team(name ?team1)(morale ?mor1)(concentration ?con1))
	?T2 <- (team(name ?team2)(morale ?mor2)(concentration ?con2))
	?M <- (match(A-nation ?team1)(B-nation ?team2)(A-location "Away")(time-slot ?time))
	=>
	(modify ?P (processed 5))
	(modify ?T1 (morale (- ?mor1 3)) (concentration (- ?con1 2)) )
	(modify ?T2 (morale (+ ?mor2 5)) (concentration (+ ?con2 3)) )
)

(defrule feelingchange3-3
	?P <- (prestate (processed 4)(team1 ?team1)(team2 ?team2))
	?T1 <- (team(name ?team1)(morale ?mor1)(concentration ?con1))
	?T2 <- (team(name ?team2)(morale ?mor2)(concentration ?con2))
	?M <- (match(A-nation ?team1)(B-nation ?team2)(A-location "Near")(time-slot ?time))
	=>
	(modify ?P (processed 5))
	(modify ?T1 (morale (+ ?mor1 2)) (concentration (+ ?con1 1)) )
	(modify ?T2 (morale (- ?mor2 2)) (concentration (- ?con2 1)) )
)

(defrule feelingchange3-4
	?P <- (prestate (processed 4)(team1 ?team1)(team2 ?team2))
	?T1 <- (team(name ?team1)(morale ?mor1)(concentration ?con1))
	?T2 <- (team(name ?team2)(morale ?mor2)(concentration ?con2))
	?M <- (match(A-nation ?team1)(B-nation ?team2)(A-location "Far")(time-slot ?time))
	=>
	(modify ?P (processed 5))
	(modify ?T1 (morale (- ?mor1 2)) (concentration (- ?con1 1)) )
	(modify ?T2 (morale (+ ?mor2 2)) (concentration (+ ?con2 1)) )
)

(defrule feelingchange4
	?P <- (prestate (processed 5)(team1 ?team1)(team2 ?team2))
	?T1 <- (team(name ?team1)(morale ?mor1)(concentration ?con1))
	?T2 <- (team(name ?team2)(morale ?mor2)(concentration ?con2))
	=>
	(modify ?P (processed 6))
	(modify ?T1 (morale (- ?mor1 (integer(/ (- ?mor1 50) 15))))
		(concentration (- ?con1 (integer(/ (- ?con1 50) 15))))	)
	(modify ?T2 (morale (- ?mor2 (integer(/ (- ?mor2 50) 15))))
		(concentration (- ?con2 (integer(/ (- ?con2 50) 15))))	)
)

(defrule feelingchange5
	?P <- (prestate (processed 6)(team1 ?team1)(team2 ?team2))
	?T1 <- (team(name ?team1)(morale ?mor1)(concentration ?con1))
	?T2 <- (team(name ?team2)(morale ?mor2)(concentration ?con2))
	=>
	(modify ?P (processed 7))
	(modify ?T1 (morale (min (100 ?mor1))) (concentration (min (100 ?con1))) )
	(modify ?T2 (morale (min (100 ?mor2))) (concentration (min (100 ?con2))) )
)
