(defrule checkscore1-1
	?P <- (prestrategy (processed 0)(teamname ?nation))
	(match (A-nation ?nation)(A-score ?scr1)(B-score ?scr2))
	=>
	(modify ?P (processed 1))
	(if ( = ?scr1 ?scr2 )
		then (assert (tied at ?scr1))
	)
	(if ( > ?scr1 ?scr2 )
		then (assert (winning ?scr1 ?scr2))
	)
	(if ( < ?scr1 ?scr2 )
		then (assert (losing ?scr1 ?scr2))
	)
)

(defrule checkscore1-2
	?P <- (prestrategy (processed 0)(teamname ?nation))
	(match (B-nation ?nation)(A-score ?scr2)(B-score ?scr1))
	=>
	(modify ?P (processed 1))
	(if ( = ?scr1 ?scr2 )
		then (assert (tied at ?scr1))
	)
	(if ( > ?scr1 ?scr2 )
		then (assert (winning ?scr1 ?scr2))
	)
	(if ( < ?scr1 ?scr2 )
		then (assert (losing ?scr1 ?scr2))
	)
)

(defrule changeplayers1-1 (declare(salience 300))
	(prestrategy (processed 1)(teamname ?nation))
	?T <- (team (name ?nation)(fatigue ?fat)(squad-depth ?backup)
		(morale ?mor)(concentration ?con) )
	?M <- (match (A-nation ?nation)(A-substitutionleft ?subnum))
	(test 
		(and (> ?fat 50)(> ?backup 0)(> ?subnum 0))
	)
	=>
	( modify ?T (fatigue (- ?fat 20)) (squad-depth (- ?backup 1))
		(morale (+ ?mor 10)) (concentration (+ ?con 10)) )
	( modify ?M (A-substitutionleft (- ?subnum 1)) )
)

(defrule changeplayers1-2 (declare(salience 290))
	(prestrategy (processed 1)(teamname ?nation))
	?T <- (team (name ?nation)(fatigue ?fat)(squad-depth ?backup)
		(morale ?mor)(concentration ?con) )
	?M <- (match (B-nation ?nation)(B-substitutionleft ?subnum))
	(test 
		(and (> ?fat 50)(> ?backup 0)(> ?subnum 0))
	)
	=>
	( modify ?T (fatigue (- ?fat 20)) (squad-depth (- ?backup 1))
		(morale (+ ?mor 10)) (concentration (+ ?con 10)) )
	( modify ?M (B-substitutionleft (- ?subnum 1)) )
)

(defrule changeplayers2-1 (declare(salience 250))
	(prestrategy (processed 1)(teamname ?nation))
	?T <- (team (name ?nation)(fatigue ?fat)(teamwork ?tw)(skills ?sk)
		(morale ?mor)(concentration ?con) )
	?M <- (match (A-nation ?nation)(A-substitutionleft ?subnum))
	(test
		(and (> ?fat 70)(< ?mor 30)(> ?subnum 0))
	)
	=>
	( modify ?T (fatigue (- ?fat 30)) (teamwork (integer(/ (* ?tw 3) 4))) (skills (integer(/ (* ?sk 4) 5)))
		(morale (+ ?mor 10)) (concentration (+ ?con 10)) )
	( modify ?M (A-substitutionleft (- ?subnum 1)) )
)

(defrule changeplayers2-2 (declare(salience 240))
	(prestrategy (processed 1)(teamname ?nation))
	?T <- (team (name ?nation)(fatigue ?fat)(teamwork ?tw)(skills ?sk)
		(morale ?mor)(concentration ?con) )
	?M <- (match (B-nation ?nation)(B-substitutionleft ?subnum))
	(test
		(and (> ?fat 70)(< ?mor 30)(> ?subnum 0))
	)
	=>
	( modify ?T (fatigue (- ?fat 30)) (teamwork (integer(/ (* ?tw 3) 4))) (skills (integer(/ (* ?sk 4) 5)))
		(morale (+ ?mor 10)) (concentration (+ ?con 10)) )
	( modify ?M (B-substitutionleft (- ?subnum 1)) )
)

(defrule changeformation1-1 (declare(salience 200))
	?P <- (prestrategy (processed 1)(teamname ?nation))
	?T <- (team (name ?nation)(mainform ?mainform)(subform ?subform))
	(winning ?scr1 ?scr2)
	=>
	(modify ?P (processed 2))
	(if 
		(and ( <> 0 ?subform )( < ?mainform ?subform )) 
		then	(modify ?T (mainform ?subform)(subform ?mainform))
	)
)

(defrule changeformation1-2 (declare(salience 190))
	?P <- (prestrategy (processed 1)(teamname ?nation))
	?T <- (team (name ?nation)(mainform ?mainform)(subform ?subform))
	(losing ?scr1 ?scr2)
	=>
	(modify ?P (processed 2))
	(if
		(and ( <> 0 ?subform )( > ?mainform ?subform ))
		then	(modify ?T (mainform ?subform)(subform ?mainform))
	)
)

(defrule makestrategy1 (declare(salience 150))
	?Str <- (prestrategy (processed 2)(teamname ?nation)
		(preval ?pre)(manval ?man)(oveval ?ove)(posval ?pos)(pasval ?pas))
	(team (name ?nation)
		(hardworking ?hw)(aggresiveness ?ag)(passlength ?pl))
	=>
	(modify ?Str (processed 3))
	(assert (pretemp ( + (- 100 ?ag) (* 2 ?hw) (* 100 ?pre) ) ))
	(assert (mantemp ( + (- 100 ?ag) ?hw (* 100 ?pre) ) ))
	(assert (ovetemp ( + ?ag (* 30 ?ove) ) ))
	(assert (postemp ( + ?ag (* 40 ?pos) ) ))
	(assert (pastemp ( + ?pl (* 40 ?pas) ) ))
)

(defrule makestrategy2 
	?Str <- (prestrategy (processed 3)(teamname ?nation))
	=>
	(modify ?Str (processed 4))
	(assert (strategy(nation ?nation)))
)

(defrule makestrategy3-1
	(prestrategy (processed 4))
	?Str <- (strategy)
	?P <- (pretemp ?pretemp)
	=>
	(retract ?P)
	(if ( > ?pretemp 150 )
		then (modify ?Str (pressing TRUE)) )
)

(defrule makestrategy3-2
	(prestrategy (processed 4))
	?Str <- (strategy)
	?M <- (mantemp ?mantemp)
	=>
	(retract ?M)
	(if ( > ?mantemp 100 )
		then (modify ?Str (man-marking TRUE)) )
)

(defrule makestrategy3-3 
	(prestrategy (processed 4))
	?Str <- (strategy)
	?O <- (ovetemp ?ovetemp)
	=>
	(retract ?O)
	(if ( < ?ovetemp 50 )
		then (modify ?Str (overlapping FALSE)) )
)

(defrule makestrategy3-4
	(prestrategy (processed 4))
	?Str <- (strategy)
	?P <- (postemp ?postemp)
	=>
	(retract ?P)
	(if (< ?postemp 5)
		then (modify ?Str (position "Defensive"))
		else (
			if (> ?postemp 95)
				then (modify ?Str (position "Attacking"))
		)
	)
)

(defrule makestrategy3-4-1-1
	(prestrategy (processed 4))
	?Str <- (strategy (position ?pos))
	?W <- (winning ?scr1 ?scr2)
	(test 
		( or (eq ?pos "Normal") (> (- ?scr1 ?scr2) 1) )
	)
	=>
	(retract ?W)
	(modify ?Str (position "Defensive"))
)

(defrule makestrategy3-4-1-2
	(prestrategy (processed 4))
	?Str <- (strategy (position "Attacking"))
	?W <- (winning ?scr1 ?scr2)
	=>
	(retract ?W)
	(modify ?Str (position "Normal"))
)

(defrule makestrategy3-4-1-3
	(prestrategy (processed 4))
	?W <- (winning ?scr1 ?scr2)
	=>
	(retract ?W)
)

(defrule makestrategy3-4-2-1
	(prestrategy (processed 4))
	?Str <- (strategy (position ?pos))
	?L <- (losing ?scr1 ?scr2)
	(test
		( or (eq ?pos "Normal") (> (- ?scr2 ?scr1) 1) )
	)
	=>
	(retract ?L)
	(modify ?Str (position "Attacking"))
)

(defrule makestrategy3-4-2-2
	(prestrategy (processed 4))
	?Str <- (strategy (position "Defensive"))
	?L <- (losing ?scr1 ?scr2)
	=>
	(retract ?L)
	(modify ?Str (position "Normal"))
)

(defrule makestrategy3-4-2-3
	(prestrategy (processed 4))
	?L <- (losing ?scr1 ?scr2)
	=>
	(retract ?L)
)

(defrule makestrategy3-4-3
	(prestrategy (processed 4))
	?T <- (tied at ?scr1 ?scr2)
	=>
	(retract ?T)
)

(defrule makestrategy3-5
	(prestrategy (processed 4))
	?Str <- (strategy)
	?P <- (pastemp ?pastemp)
	=>
	(retract ?P)
	(if (< ?pastemp 5)
		then (modify ?Str (passing "Short"))
		else (
			if (> ?pastemp 95)
				then (modify ?Str (passing "Direct"))
		)
	)
)

