;structure for formation
(deftemplate form
	(slot forms(type INTEGER)(default 442))
	(slot awareness(type INTEGER)(default 80))
)

;time-slot : 0-10 in game
;            11 penaltyshootout
;            12 end of game
;            13 every process with this game is finished
;multislot formations : use 'deftemplate form'
(deftemplate team
	(slot name(type LEXEME)(default unknown))
	(slot location(type INTEGER)(default 8))
	(slot reputation(type INTEGER)(default 50))
	(slot skills(type INTEGER)(default 50))
	(slot teamwork(type INTEGER)(default 50))
	(slot squad-depth(type INTEGER)(default 0))
	(slot stamina(type INTEGER)(default 50))
	(slot morale(type INTEGER)(default 50))
	(slot fatigue(type INTEGER)(default 0))
	(slot concentration(type INTEGER)(default 50))
	(slot mainform(type INTEGER)(default 442))
	(slot subform(type INTEGER)(default 0))
	(slot hardworking(type INTEGER)(default 50))
	(slot aggresiveness(type INTEGER)(default 50))
	(slot passlength(type INTEGER)(default 50))
)

;position : Attacking - Normal - Defensive
;attacking direction : Center - Mixed - Side
;passing type : Direct - Mixed - Short
;dribble-pass preference : Dribble - Mixed - Pass
;overlap : YES - NO
;long-shoots : Frequent - General - Rare
;tempo : 5(very fast) - 4(fast) - 3(normal) - 2(slow) - 1(very slow)
(deftemplate strategy
;	(slot matchID(type INTEGER))	
	(slot nation(type LEXEME))
	(slot pressing(default FALSE))
	(slot man-marking(default FALSE))
	(slot overlapping(default TRUE))
	(slot position(type LEXEME)(default "Normal"))
	(slot passing(type LEXEME)(default "Mixed"))
;	(slot dribble(type LEXEME)(default "Mixed"))
;	(slot att-dir(type LEXEME)(default "Mixed"))
;	(slot long-shoots(type LEXEME)(default "General"))
;	(slot tempo(type INTEGER)(default 3))
)

;processed : new data - 0 , processed data - 1
;
(deftemplate prestrategy
	(slot processed(type INTEGER)(default 0))
	(slot teamname(type LEXEME))
	(slot preval(type INTEGER))
	(slot manval(type INTEGER))
	(slot oveval(type INTEGER))
	(slot posval(type INTEGER))
	(slot pasval(type INTEGER))
)

(deftemplate prestate
	(slot processed(type INTEGER)(default 0))
	(slot team1(type LEXEME))
	(slot team2(type LEXEME))
	(slot off1(type LEXEME))
	(slot off2(type LEXEME))
	(slot pos1(type LEXEME))
	(slot pos2(type LEXEME))
	(slot def1(type LEXEME))
	(slot def2(type LEXEME))
)

;weather : Sunny - Hot - Cloud - Rain - Cold - Snow
;location : the smaller the difference, the better,
;           real home if difference is 0 (0~10)
; 3-KOREA 2-JAPAN
;number of allowed substitution per game
;match-type : 16, 8, 4, 2
;match-slot : 16 has 8slots, 8 has 4slots. needed for tornament structure.
;date : 3rd July -> 0703
;when : Day, Evening, Night
;time slot : 0~12 (0-10: Game), 11: Penalty 12: Mathch Fin. 13: Post Cond.
;A-location : Home, Away, Near, Far
(deftemplate match
	(slot weather(type LEXEME)(default "Sunny"))
	(slot location(type INTEGER)(default 3))
	(slot num-sub(type INTEGER)(default 3))
	(slot match-type(type INTEGER))
	(slot match-slot(type INTEGER))
	(slot matchID(type INTEGER))
	(slot date(type INTEGER))
	(slot when(type LEXEME)(default "Evening"))
	(slot time-slot(type INTEGER)(default 0))
	(slot status(type INTEGER)(default 0))
	(slot A-nation(type LEXEME))
	(slot B-nation(type LEXEME))
	(slot A-score(type INTEGER)(default 0))
	(slot B-score(type INTEGER)(default 0))
	(slot A-substitutionleft(type INTEGER)(default 3))
	(slot B-substitutionleft(type INTEGER)(default 3))
	(slot A-location(type LEXEME))
	(slot B-location(type LEXEME))
	(slot winner(type LEXEME)(default "Not Finished"))
)

;report for an injury 
;player's nationality
;start date and timeslot of the game
;date for recovery, so can get back to game
(deftemplate injury
	(slot nation(type LEXEME))
	(slot begin-date(type INTEGER))
	(slot begin-time(type INTEGER))
	(slot end-date(type INTEGER))
)


